/*
 *  TOPPERS ECHONET Lite Communication Middleware
 * 
 *  Copyright (C) 2016 Cores Co., Ltd. Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: main.h 167 2016-03-08 11:37:45Z coas-nagasima $
 */

#ifndef _MAIN_H_
#define _MAIN_H_

/*
 *		TvvO(1)̃wb_t@C
 */

/*
 *  ^[Qbgˑ̒`
 */
#include <kernel.h>
#include "target_config.h"
#include "echonet.h"

/*
 *  e^XN̗Dx̒`
 */

#define MAIN_PRIORITY	5		/* C^XN̗Dx */

#define MAIN_STACK_SIZE	1024	/* X^bN̈̃TCY */

#define EOJ_X3_LOCAL_NODE 1	/* m[hvt@CIuWFNg̃CX^XR[h */

#define EOJ_X3_ELECTRIC_ENERGY_METER_1 1	/* d͗ʃ[^P̃CX^XR[h */
#define EOJ_X3_ELECTRIC_ENERGY_METER_2 2	/* d͗ʃ[^Q̃CX^XR[h */
#define EOJ_X3_ELECTRIC_ENERGY_METER_3 3	/* d͗ʃ[^R̃CX^XR[h */
#define EOJ_X3_ELECTRIC_ENERGY_METER_4 4	/* d͗ʃ[^S̃CX^XR[h */
#define EOJ_X3_ELECTRIC_ENERGY_METER_5 5	/* d͗ʃ[^T̃CX^XR[h */
#define EOJ_X3_ELECTRIC_ENERGY_METER_6 6	/* d͗ʃ[^ŨCX^XR[h */

#define	KMM_SIZE	8192		/* J[lt郁̈̃TCY */

/*
 *  ֐̃vg^Cv錾
 */
#ifndef TOPPERS_MACRO_ONLY

extern void main_task(intptr_t exinf);

#ifdef __CA850__
#pragma pack(1)
#elif __RX
#pragma pack
#elif _MSC_VER
#pragma pack(push, 1)
#endif

/*
 *  ǔ^
 */
struct version_information_t {
	/* W[o[W(_ȏ) */
	uint8_t major_version_number;
	/* }Ci[o[W(_ȉ) */
	uint8_t minor_version_number;
	/* d^Cv */
	uint8_t message_type[2];
};

/*
 *  [J[R[ȟ^
 */
struct manufacturer_code_t {
	/* [J[R[h */
	uint8_t manufacturer_code[3];
};

/*
 *  ʔԍ̌^
 */
struct node_identification_number_t {
	/* ʒʐMwIDtB[h */
	uint8_t lower_communication_id_field;
	/* [J[R[h */
	struct manufacturer_code_t manufacturer_code;
	/* j[NID([J[Ǝ) */
	uint8_t unique_id_section[13];
};

/*
 *  Kiǔ^
 */
struct standard_version_information_t {
	/* Œ1(for future reserved) */
	uint8_t reserved1;
	/* Œ2(for future reserved) */
	uint8_t reserved2;
	/* [XASCIIŎ */
	uint8_t order_of_release;
	/* Œ4(for future reserved) */
	uint8_t reserved3;
};

/*
 *  m[hvt@CIuWFNg
 */
struct node_profile_object_t {
	/*  */
	uint8_t operation_status;
	/* u */
	struct version_information_t version_information;
	/* ʔԍ */
	struct node_identification_number_t identification_number;
	/* ُe */
	uint16_t fault_content;
	/* [J[R[h */
	struct manufacturer_code_t manufacturer_code;
};

/*
 *  d͗ʃ[^
 */
struct watt_hour_meter_t {
	/*  */
	uint8_t operation_status;
	/* ݒuꏊ */
	uint8_t installation_location;
	/* Kiu */
	struct standard_version_information_t standard_version_information;
	/* ُ픭 */
	uint8_t fault_status;
	/* [J[R[h */
	struct manufacturer_code_t manufacturer_code;
	/* ώZd͗ʒP */
	uint8_t integral_electric_energy_unit;
	/* ώZd͗ʌvl */
	uint32_t integral_electric_energy_measurement_value;
	/* ώZd͗ʌvlP */
	uint32_t integral_electric_energy_measurement_log[48];
	int current_pos;
};

#ifdef __CA850__
#pragma pack(8)
#elif __RX
#pragma unpack
#elif _MSC_VER
#pragma pack(pop)
#endif

extern struct node_profile_object_t local_node_data;	/* m[hvt@CIuWFNg̃f[^ */

extern struct watt_hour_meter_t electric_energy_meter_data[6];	/* d͗ʃ[^P`Ũf[^ */

EPRP_SETTER onoff_prop_set;
EPRP_SETTER alarm_prop_set;
EPRP_SETTER time_prop_set;
EPRP_GETTER time_prop_get;
EPRP_SETTER date_prop_set;
EPRP_GETTER date_prop_get;
EPRP_GETTER watt_hour_meter_integral_electric_energy_measurement_value_get;
EPRP_GETTER watt_hour_meter_integral_electric_energy_unit_get;
EPRP_GETTER watt_hour_meter_integral_electric_energy_measurement_log_get;

#endif /* TOPPERS_MACRO_ONLY */

#endif	/* of #ifndef _MAINN_H_ */
